const app = require("express")();
const database = require('./database');

//Default at 8090 to enable easy development
const port = process.env.PORT || 8090;

//OLD (Single point)
app.get("/generatePoint", (req,res) => {
  console.log("Generating single point")
  res.send({"point": generatePoint()})
})

//Sends the stream Had to limit the speed with intervals
// Otherwise it sends 2.000.000+ points a sec
app.get("/generatePointStream",(req,res)=>{

  let modelID = req.query.modelID;
  console.log(modelID);


  //temp disable
  if(true){
  streamGeneratedPoints(res);
  return
  }

  if(modelID == "undefined"){
    streamGeneratedPoints(res);
  }
  else{
    streamDatabasePoints(res);
  }
})

function streamDatabasePoints(res){
  console.log("Sending database points")
  database.executeQuery("SELECT * from SAMPLE.dbo.pointTable",function(data){sendDatabasePoints(data,res);});
}

function sendDatabasePoints(dataList,res){
  console.log(dataList.length);
  for(var i = 0; i<dataList.length;i++){
    var currentData = dataList[i];

    var point = {id: currentData[0].value, x: currentData[1].value, y:currentData[2].value};
    
    var response = JSON.stringify({"point":point});
    res.write(response+"\n");
  }
  res.end();
}

let pointId = 0;

function streamGeneratedPoints(res){
  console.log("Sending generated points");
  var intervalId = setInterval(() => {    
    for (var i = 0; i < 100; i++) {
      var response = JSON.stringify({ point: generatePoint() });
      res.write(response + "\n");

      if (pointId % 100000 === 0) {
        res.end();

        clearInterval(intervalId)
        break;
      }
    }
  }, 10);
}

//Generate randomPoint
function generatePoint() {
  const id = pointId++;
  const x = Math.floor(Math.random() * 100);
  const y = Math.floor(Math.random() * 100);

  return { id, x, y };
}

app.listen(port, () => {
  console.log(`Server listening at http://0.0.0.0:${port}`);
});